Class ColorTranslationWrapper play
{
	static int GenerateRandomColorTranslation()
	{
		String lmp = Wads.ReadLump(Wads.FindLump("PLAYPAL"));
		Translation t;
		int COLOR_VARIETY = 52 - ue_colour_v; // the lower this value is, the more psychedelic the result
		int BRGHT = ue_colour_b; // Minimum Brightness
		Color blend = Color(Random(BRGHT, 255), Random(BRGHT, 255), Random(BRGHT, 255));
		for ( int i=0; i<256; i++ )
		{
			if (random(1, COLOR_VARIETY) == 1)
			{
				blend = Color(Random(BRGHT, 255), Random(BRGHT, 255), Random(BRGHT, 255));
			}
			
			int r = lmp.ByteAt(i*3);
			int g = lmp.ByteAt(i*3+1);
			int b = lmp.ByteAt(i*3+2);
			if ( r < 0 ) r = 256 + r;
			if ( g < 0 ) g = 256 + g;
			if ( b < 0 ) b = 256 + b;
			switch(ue_colour_t)
			{
				case 0: // multiply per color channel
				t.colors[i] = Color( i ? 255:0, (r * blend.r) / 255, (g * blend.g) / 255, (b * blend.b) / 255 );
				break;
				
				case 1: // multiply by brightness
				int avg = round((r + g + b) / 3);
				t.colors[i] = Color( i ? 255:0, (avg * blend.r) / 255, (avg * blend.g) / 255, (avg * blend.b) / 255 );
				break;
				
				case 2: // averaging
				t.colors[i] = Color( i ? 255:0, (r + blend.r + avg) / 3, (g + blend.g + avg) / 3, (b + blend.b + avg) / 3 );
				break;
			}
		}
		return t.AddTranslation();
	}
}
